
/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License.                 *
*   See LICENSE.TXT for further information.                                *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1985,1991  Digital Research Inc.  All rights reserved.    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/dsk/rcs/deskdos.h 3.4 92/04/03 17:09:14 sbc Exp $
* $Log:	deskdos.h $
 * Revision 3.4  92/04/03  17:09:14  sbc
 * WNODEs and PNODEs to fars, lots of other housekeeping
 * 
 * Revision 3.3  92/02/27  09:40:19  sbc
 * Allow assignment of icon to ordinary FNODE.
 * 
 * Revision 3.2  92/01/31  16:38:06  sbc
 * remove define of DTA. Add define for FCB.
 * 
 * Revision 3.1  91/08/19  16:30:35  system
 * ViewMAX 2 sources
 * 
 * Revision 1.3  91/06/14  07:41:41  sbc
 * rm unused defines; add READWRITE and READONLY access flags for dos_open().
 * 
 * Revision 1.2  91/06/07  10:25:20  whf
 * added E_PASSWFAIL symbolic name
 * 
 * Revision 1.1  91/06/05  13:01:10  sbc
 * Initial revision
 * 
* Revision 3.2  91/06/04  13:07:41  sbc
* misc housekeeping and other ravings...
* 
* Revision 3.1  91/05/16  14:48:39  fontes
* Separate branch for Beta bug fixes, separate from split-mode windows
* 
* Revision 2.1.1.3  91/04/08  11:59:41  fontes
* Re-activate some calls needed for list boxes and other ext. objects
* 
* Revision 2.1.1.2  91/03/25  14:40:36  anderson
* Converted to medium model, prototyped, and generally cleaned up.
* 
Date	Who	SPR#	Comments
-------	-------	----	-------------------------------------------------------
910321	RSF		Brought in def for dta
*****************************************************************************/

/****************************************************************************
* File:		deskdos.h
*
* Description:	
*
* Build Info:	ndmake -f vm2.mak
*
* Overview:	
*  
*****************************************************************************/

#if !defined( DESKDOS_INCLUDED )
    #define DESKDOS_INCLUDED

#define READONLY	0		/* access modes for dos_open() */
#define READWRITE	2

#define E_BADFUNC 1
#define E_FILENOTFND 2
#define E_PATHNOTFND 3
#define E_NOHANDLES 4
#define E_NOACCESS 5
#define E_BADHANDLE 6
#define E_MEMBLKERR 7
#define E_NOMEMORY 8
#define E_BADMEMBLK 9
#define E_BADENVIR 10
#define E_BADFORMAT 11
#define E_BADACCESS 12
#define E_BADDATA 13
#define E_BADDRIVE 15
#define E_NODELDIR 16
#define E_NOTDEVICE 17
#define E_NOFILES 18
#define	E_PASSWFAIL 0x56

#define F_RDONLY 0x01
#define F_HIDDEN 0x02
#define F_SYSTEM 0x04
#define F_VOLUME 0x08
#define F_SUBDIR 0x10
#define F_ARCHIVE 0x20
						/* DESKTOP FLAGS for	*/
						/*   attribute byte	*/
#define F_PROGITEM	0x08				
#define F_FAKEFOLD	0x40
#define F_DISK		0x80

#define F_GETMOD 0x0
#define F_SETMOD 0x1

typedef struct exec_blk
{
	WORD		eb_segenv;
	LONG		eb_pcmdln;
	LONG		eb_pfcb1;
	LONG		eb_pfcb2;
} EXEC_BLK;

struct internat				/* country code info structure */
{
    WORD	dt_fmt;		/* 0=MM/DD/YY 1=DD/MM/YY 2=YY/MM/DD	*/
    BYTE	currcy[5];	/* currency symbol + nulls		*/
    BYTE	d1000[2];	/* thousands delimiter + null		*/
    BYTE	ddecm[2];	/* decimal delimiter + null		*/
    BYTE	ddate[2];	/* date delimiter + null		*/
    BYTE	dtime[2];	/* time delimiter + null		*/
    BYTE	cflg;		/* currcy sym bits: 01 trailing, 02 = spaced */
    BYTE	cdec;		/* number of decimal places in currency */
    BYTE	ampm;		/* 0=am/pm 1=24h clock			*/
    WORD	ucase[2];	/* address of toupper function */
    BYTE	dlist[2];	/* data list separator + null 		*/
    WORD	reserved[5];
    UWORD code;	/* Country code	*/
};

typedef struct tag_fcb
{
	BYTE		fcb_reserved[21];
	BYTE		fcb_attr;
	WORD		fcb_time;
	WORD		fcb_date;
	LONG		fcb_size;
	BYTE		fcb_name[13];
} FCB ;

#if 0
typedef struct data_trans
{
    BYTE dta_reserved[21];
    BYTE dta_attr;
    BYTE dta_time[2];
    BYTE dta_date[2];
    LONG dta_size;
    BYTE dta_name[13];
} DTA;
#endif

#endif
/*
 *	EOF:	deskdos.h
 */
